SystemOrganization addCategory: #'Alt-Refactoring-Commands'!

!ABMethodNode methodsFor: '*Alt-Refactoring-Commands' stamp: 'ThierryGoubier 8/1/2012 16:38'!
formatCommand
	<textAreaCommand>
	^ {ABFormatCommand}! !

!ABMethodCategoryNode methodsFor: '*Alt-Refactoring-Commands' stamp: 'ThierryGoubier 8/7/2012 22:28'!
formatCommand
	<textAreaCommand>
	^ {ABFormatCommand}! !

ABCommand subclass: #ABFormatCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Refactoring-Commands'!

!ABFormatCommand commentStamp: '<historical>' prior: 0!
This class is for the source code formatting command.
!

!ABFormatCommand methodsFor: 'execution' stamp: 'ThierryGoubier 9/28/2012 21:49'!
execute
	"Code derived from ORFormatCmd (OmniBrowser) and simplified. Will fail silently if the code is incorrect."

	| source tree formatted |
	source := target text asString.
	tree := RBParser parseMethod: source onError: [ :msg :pos | ^ self ].
	formatted := tree formattedCode.
	formatted = source
		ifTrue: [ ^ self ].
	target
		editString: formatted;
		hasUnacceptedEdits: true! !

!ABFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:31'!
icon
	^ nil! !

!ABFormatCommand methodsFor: 'testing' stamp: 'ThierryGoubier 8/1/2012 16:36'!
isActive
	^ true! !

!ABFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 8/1/2012 16:31'!
keystroke
	^ $r ctrl! !

!ABFormatCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 9/12/2012 15:12'!
label
	^ 'Format'! !
